Summary:	JPEG XL reference implementation
Summary(pl.UTF-8):	Referencyjna implementacja JPEG XL
Name:		libjxl
Version:	0.6.1
Release:	2
License:	BSD
Group:		Libraries
#Source0Download: https://github.com/libjxl/libjxl/releases
Source0:	https://github.com/libjxl/libjxl/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	5dae0f40ad6180c1b168bbf7edaf8e7d
Patch0:		%{name}-system-libs.patch
Patch1:		%{name}-hwy.patch
Patch2:		%{name}-pc.patch
URL:		https://github.com/libjxl/libjxl
BuildRequires:	OpenEXR-devel
BuildRequires:	asciidoc
BuildRequires:	cmake >= 3.10
BuildRequires:	doxygen
BuildRequires:	gdk-pixbuf2-devel >= 2.38
BuildRequires:	giflib-devel >= 5
BuildRequires:	gimp-devel >= 1:2.10
BuildRequires:	gmock-devel
BuildRequires:	google-benchmark-devel
BuildRequires:	gtest-devel
BuildRequires:	highway-devel >= 0.15.0
BuildRequires:	lcms2-devel >= 2.10
BuildRequires:	libavif-devel
BuildRequires:	libbrotli-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libwebp-devel
BuildRequires:	libstdc++-devel >= 6:7
BuildRequires:	lodepng-devel
BuildRequires:	pkgconfig
BuildRequires:	python3-devel >= 1:3
BuildRequires:	rpmbuild(macros) >= 1.605
# for gdk-pixbuf loader only (the rest uses lcms2 by default)
BuildRequires:	skcms-devel
BuildRequires:	zlib-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if "%{_lib}" != "lib"
%define		libext		%(lib="%{_lib}"; echo ${lib#lib})
%define		pqext		-%{libext}
%else
%define		pqext		%{nil}
%endif

%description
JPEG XL reference implementation.

%description -l pl.UTF-8
Referencyjna implementacja JPEG XL.

%package tools
Summary:	Tools to encode and decode JPEG XL files
Summary(pl.UTF-8):	Narzędzia do kodowania i dekodowania plików JPEG XL
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}

%description tools
Tools to encode and decode JPEG XL files.

%description tools -l pl.UTF-8
Narzędzia do kodowania i dekodowania plików JPEG XL.

%package devel
Summary:	Header files for JXL libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek JXL
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	highway-devel >= 0.15.0
Requires:	lcms2-devel >= 2.10
Requires:	libbrotli-devel
Requires:	libstdc++-devel >= 6:7

%description devel
Header files for JXL libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek JXL.

%package static
Summary:	Static JXL libraries
Summary(pl.UTF-8):	Statyczne biblioteki JXL
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static JXL libraries.

%description static -l pl.UTF-8
Statyczne biblioteki JXL.

%package -n gdk-pixbuf2-loader-jxl
Summary:	JPEG XL loader module for gdk-pixbuf2 library
Summary(pl.UTF-8):	Moduł biblioteki gdk-pixbuf2 wczytujący pliki JPEG XL
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	gdk-pixbuf2 >= 2.38
Requires:	shared-mime-info

%description -n gdk-pixbuf2-loader-jxl
JPEG XL loader module for gdk-pixbuf2 library.

%description -n gdk-pixbuf2-loader-jxl -l pl.UTF-8
Moduł biblioteki gdk-pixbuf2 wczytujący pliki JPEG XL.

%package -n gimp-plugin-jxl
Summary:	JPEG XL load/save plugin for GIMP
Summary(pl.UTF-8):	Wtyczka wczytująca/zapisująca pliki JPEG XL dla GIMP-a
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}
Requires:	gimp >= 1:2.10

%description -n gimp-plugin-jxl
JPEG XL load/save plugin for GIMP.

%description -n gimp-plugin-jxl -l pl.UTF-8
Wtyczka wczytująca/zapisująca pliki JPEG XL dla GIMP-a.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
install -d build
cd build
%cmake .. \
	-DBUILD_TESTING=OFF \
	-DJPEGXL_ENABLE_PLUGINS=ON \
	-DJPEGXL_ENABLE_SJPEG=OFF \
	-DJPEGXL_ENABLE_SKCMS=OFF \
	-DJPEGXL_ENABLE_TCMALLOC=OFF \
	-DJPEGXL_FORCE_SYSTEM_BROTLI=ON \
	-DJPEGXL_FORCE_SYSTEM_GTEST=ON \
	-DJPEGXL_FORCE_SYSTEM_HWY=ON

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n gdk-pixbuf2-loader-jxl
umask 022
%{_bindir}/gdk-pixbuf-query-loaders%{pqext} --update-cache || :
%update_mime_database

%postun	-n gdk-pixbuf2-loader-jxl
%update_mime_database
if [ "$1" != "0" ]; then
	umask 022
	[ ! -x %{_bindir}/gdk-pixbuf-query-loaders%{pqext} ] || \
	%{_bindir}/gdk-pixbuf-query-loaders%{pqext} --update-cache || :
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGELOG.md CONTRIBUTORS LICENSE PATENTS README.md SECURITY.md doc/xl_overview.md
%attr(755,root,root) %{_libdir}/libjxl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjxl.so.0.6
%attr(755,root,root) %{_libdir}/libjxl_threads.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjxl_threads.so.0.6

%files tools
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/benchmark_xl
%attr(755,root,root) %{_bindir}/cjxl
%attr(755,root,root) %{_bindir}/djxl
%{_mandir}/man1/cjxl.1*
%{_mandir}/man1/djxl.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjxl.so
%attr(755,root,root) %{_libdir}/libjxl_threads.so
%{_libdir}/libjxl_dec.a
%{_includedir}/jxl
%{_pkgconfigdir}/libjxl.pc
%{_pkgconfigdir}/libjxl_threads.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libjxl.a
%{_libdir}/libjxl_threads.a

%files -n gdk-pixbuf2-loader-jxl
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/gdk-pixbuf-2.0/2.10.0/loaders/libpixbufloader-jxl.so
%{_datadir}/mime/packages/image-jxl.xml
%{_datadir}/thumbnailers/jxl.thumbnailer

%files -n gimp-plugin-jxl
%defattr(644,root,root,755)
%dir %{_libdir}/gimp/2.0/plug-ins/file-jxl
%attr(755,root,root) %{_libdir}/gimp/2.0/plug-ins/file-jxl/file-jxl
%changelog
* Tue May 03 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libjxl.git;a=log;h=master

* Tue May 03 2022 Jakub Bogusz <qboosh@pld-linux.org> 00e45f8
- added pc patch (support absolute CMAKE_INSTALL_{INCLUDE,LIB}DIR in .pc files); release 2

* Sun Apr 10 2022 Jakub Bogusz <qboosh@pld-linux.org> 00662d4
- updated to 0.6.1
- updated system-libs patch
- added hwy patch (updates for highway 0.16.0 from git)

* Sun Apr 10 2022 Jan Rękorajski <baggins@pld-linux.org> 9c964b9
- BR google-benchmark-devel for jxl_gbench tool, rel 6

* Sat Apr 09 2022 Jan Rękorajski <baggins@pld-linux.org> 6d9a9da
- Release 5 (by relup.sh)

* Mon Feb 14 2022 Jan Rękorajski <baggins@pld-linux.org> 386a3e9
- Release 4 (by relup.sh)

* Mon Feb 14 2022 Jan Rękorajski <baggins@pld-linux.org> 53ed286
- added lodepng build dep

* Sat Feb 05 2022 Jan Rękorajski <baggins@pld-linux.org> 16f67f2
- Release 3 (by relup.sh)

* Fri Oct 22 2021 Jakub Bogusz <qboosh@pld-linux.org> 91d6304
- missing dir, release 2

* Tue Oct 05 2021 Jakub Bogusz <qboosh@pld-linux.org> fe1629d
- new; system libs patch to use system lcms2 (and possibly lodepng, sjpeg, skcms)

